(* Lexer pour sous-ensemble de pascal *)

{ (* début du header *)

  (* Modules auxiliaires *)
open Lexing
open Parser
open Error_handler

  (* Quelques listes d'associations *)
   
let special_chars = [
  ( '+'       ,     ADD )  ;
  ( '-'       ,     SUB )  ;
  ( '*'       ,     MUL )  ;
  ( '/'       ,     RDIV ) ;
  ( '='       ,     EQUALS );
  ( '<'       ,     LESS );
  ( '>'       ,     GREAT );
  ( '['       ,     LBRA ) ;
  ( ']'       ,     RBRA ) ;
  ( '.'       ,     DOT )  ;
  ( ','       ,     COMMA ) ;
  ( '('       ,     LPAR ) ;
  ( ')'       ,     RPAR ) ;
  ( ':'       ,     COLON );
  ( ';'       ,     SEMICOL ) ;
  ]

let reserved_words = [
  (  "and"             , AND                ) ;
  (  "array"           , ARRAY              ) ;
  (  "begin"           , BEGIN              ) ;
  (  "const"           , CONST              ) ;
  (  "div"             , DIV                ) ;
  (  "do"              , DO                 ) ;
  (  "downto"          , DOWNTO             ) ;
  (  "else"            , ELSE               ) ;
  (  "end"             , END                ) ;
  (  "for"             , FOR                ) ;
  (  "function"        , FUNCTION           ) ;
  (  "if"              , IF                 ) ;
  (  "mod"             , MOD                ) ;
  (  "not"             , NOT                ) ;
  (  "of"              , OF                 ) ;
  (  "or"              , OR                 ) ;
  (  "procedure"       , PROCEDURE          ) ;
  (  "program"         , PROGRAM            ) ;
  (  "record"          , RECORD             ) ;
  (  "repeat"          , REPEAT             ) ;
  (  "return"          , RETURN             ) ;
  (  "then"            , THEN               ) ;
  (  "to"              , TO                 ) ;
  (  "type"            , TYPE               ) ;
  (  "until"           , UNTIL              ) ;
  (  "var"             , VAR                ) ;
  (  "while"           , WHILE              ) ;
  (  "with"            , WITH               ) ;
  (  "xor"             , XOR                ) ;
]


} (* fin du header *)

(************)
(* lexing   *)
(************)

let digit =  ...
let letter = ...

rule token = parse
| eof              { EOF  }
| '\n'             { token lexbuf }  (* '\n' not meaningful *)
| [' ' '\t' '\r' ] { ... }

| ...


{ (* début du trailer *)

  (* pas besoin de trailer pour nous *)

} (* fin du trailer *)
