open Parser

let string_of_token = function
  | ADD  -> "+"
  | SUB  -> "-"
  | MUL  -> "*"
  | RDIV  -> "/"
  | ADDE  -> "+="
  | SUBE  -> "-="
  | MULE  -> "*="
  | RDIVE  -> "/="
  | EQUALS  -> "="
  | LESS  -> "<"
  | GREAT  -> ">"
  | LEQ -> "<="
  | GEQ -> ">="
  | DIFF -> "<>"
  | LBRA  -> "["
  | RBRA  -> "]"
  | DOT  -> "."
  | COMMA  -> ","
  | LPAR  -> "("
  | RPAR  -> ")"
  | COLON  -> ":"
  | SEMICOL  -> ";"
  | ASSIGN -> ":="

  |  AND                 -> "and"
  |  ARRAY               -> "array"
  |  BEGIN               -> "begin"
  |  CONST               -> "const"
  |  DIV                 -> "div"
  |  DO                  -> "do"
  |  DOWNTO              -> "downto"
  |  ELSE                -> "else"
  |  END                 -> "end"
  |  FOR                 -> "for"
  |  FUNCTION            -> "function"
  |  IF                  -> "if"
  |  MOD                 -> "mod"
  |  NOT                 -> "not"
  |  OF                  -> "of"
  |  OR                  -> "or"
  |  PROCEDURE           -> "procedure"
  |  PROGRAM             -> "program"
  |  RECORD              -> "record"
  |  REPEAT              -> "repeat"
  |  RETURN              -> "return"
  |  THEN                -> "then"
  |  TO                  -> "to"
  |  TYPE                -> "type"
  |  UNTIL               -> "until"
  |  VAR                 -> "var"
  |  WHILE               -> "while"
  |  WITH                -> "with"
  |  XOR                 -> "xor"

  | EOF  -> "end of file"

  | INT n -> string_of_int n
  | STR s -> "\"" ^ s ^ "\""
  | WORD s -> "__" ^ s ^ "__"


let print_token t =
  print_string ("'" ^ string_of_token t ^ "' " )
